//#define _GLIBCXX_DEBUG
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops,tune-native,avx,fma")
#include <bits/stdc++.h>
//#define int long long
#define endl '\n'
#define fast ios_base::sync_with_stdio(false);cout.tie(nullptr);cin.tie(nullptr);
using namespace std;
vector<vector<int>> g;
int n;
int mp[1000001];
//map<pair<int,int>,bool>memo;
bool used[100001];
bool dfs(int v,int p,int c_ti=1){
    if(c_ti==n){
        for(auto i:g[v]){
            if(i==1){
                mp[v]=1;
                return true;
            }
        }
        return false;
    }
    bool f=0;
    for(auto i:g[v]){
        if(i!=p && !used[i]){
            used[i]=true;
            f|=dfs(i,v,c_ti+1);
            if(f){
                mp[v]=i;
                return true;
            }
            used[i]=false;
        }
    }
    return f;
}
void Bogdan(){
    int m;
    cin>>n>>m;
    g.resize(n+1);
    int l,r;
   for(int i=0;i<m;i++){
        cin>>l>>r;
        g[l].push_back(r);
    }
    for(int i=1;i<=n;i++){
        if(!g[i].size()){
            cout<<"NO"<<endl;
            return;
        }
    }
    bool f=dfs(1,0);
    cout<<(f?"YES":"NO")<<endl;
    if(f){
        int cur=1;
        cout<<1<<' ';
        while(mp[cur]!=1){
            cout<<mp[cur]<<' ';
            cur=mp[cur];
        }
        cout<<1<<endl;
    }
}
/*
*/
int32_t main(){
    fast;
    int t=1,n;
   // cin>>t;
    while(t--){
        Bogdan();
    }
}
